
'
'   File:    lo1.vb
'
'   Purpose: Demonstrates how to solve small linear
'            optimization problem using the MOSEK .net API.
'
Imports System,mosek


public class MsgTest
    Inherits mosek.Stream
    Dim name As String

    Public Sub New (e As mosek.Env, n As String)
'        MyBase.New ()
        name = n
    End Sub

    Public Overrides Sub streamCB (msg As String)
        Console.Write ("{0}: {1}", name, msg)
    End Sub
End Class


module lo1
    public sub main ()
        dim NUMCON as Integer = 3
        dim NUMVAR as Integer = 4

        dim bkc as boundkey() = { boundkey.fx, boundkey.lo, boundkey.up }
        dim bkx as boundkey() = { boundkey.lo, boundkey.ra, boundkey.lo, boundkey.lo }

        dim ptrb as Integer() = { 0, 2, 5, 7}
        dim ptre as Integer() = { 2, 5, 7, 9 }
        dim subs as Integer() = { 0, 1, _
                                  0, 1, 2, _
                                  0, 1, _
                                  1, 2 }

        dim blc as Double() = { 30.0, 15.0, -mosek.Val.infinity }
        dim buc as Double() = { 30.0, mosek.Val.infinity, 25.0 }
        dim c   as Double() = { 3.0, 1.0, 5.0, 1.0 }
        dim blx as Double() = { 0.0, 0.0, 0.0, 0,0}
        dim bux as Double() = { mosek.Val.infinity, 10, mosek.Val.infinity, mosek.Val.infinity }
        dim val as Double() = { 3.0, 2.0, _
                                1.0, 1.0, 2.0, _
                                2.0, 3.0, _
                                1.0, 3.0 }
        dim xx  as Double() = { 0, 0, 0, 0, 0 }
        
        dim task as mosek.Task
        dim env  as mosek.Env  
	dim msg as MsgTest
	
	Try
	        env  = new mosek.Env ()
        	env.init ()
        	task = new mosek.Task (env, NUMCON,NUMVAR)
		msg = New MsgTest (env, "msg")
		task.set_streamCB (streamtype.log, msg)
        
	        call task.inputdata(NUMCON, NUMVAR, _
                	            c, _
                        	    0.0, _
	                            ptrb,ptre, _
        	                    subs, _
                	            val, _
                        	    bkc, blc, buc, _
	                            bkx, blx, bux)

                task.putobjsense(mosek.objsense.maximize)

	        task.putintparam (iparam.write_generic_names, 1)
        	task.writedata ("small.lp")
    
	        task.optimize()

		Console.WriteLine ("*****************************")
		task.solutionsummary (streamtype.log)
    
	        task.getsolutionslice(soltype.itr, solitem.xx, 0, NUMVAR - 1, xx)

	        dim j as integer    
        	for j  = 0 to NUMVAR - 1
	            Console.WriteLine ("x[{0}]:{1}", j,xx(j))
        	next

	        Console.WriteLine ("Finished optimization")
	Catch e as mosek.Exception
		Console.WriteLine ("MosekException caught, {0}",e)
	Catch e as System.Exception
		Console.WriteLine ("System.Exception caught, {0}",e)
	End Try
    end sub
end module

